import { route } from 'quasar/wrappers';
import {
  createMemoryHistory,
  createRouter,
  createWebHashHistory,
  createWebHistory,
} from 'vue-router';

import routes from './routes';
import { useAuthStore } from 'src/stores/auth';

const publicRoutes = routes
  .filter((route) => route.meta?.publicRoute)
  .map((r) => r.path);

/*
 * If not building with SSR mode, you can
 * directly export the Router instantiation;
 *
 * The function below can be async too; either use
 * async/await or return a Promise which resolves
 * with the Router instance.
 */

export default route(function (/* { store, ssrContext } */) {
  const createHistory = process.env.SERVER
    ? createMemoryHistory
    : process.env.VUE_ROUTER_MODE === 'history'
    ? createWebHistory
    : createWebHashHistory;

  const Router = createRouter({
    scrollBehavior: () => ({ left: 0, top: 0 }),
    routes,

    // Leave this as is and make changes in quasar.conf.js instead!
    // quasar.conf.js -> build -> vueRouterMode
    // quasar.conf.js -> build -> publicPath
    history: createHistory(process.env.VUE_ROUTER_BASE),
  });

  Router.beforeEach(async (to, from, next) => {
    const authStore = useAuthStore();
    const currentUser = authStore.currentUser;
    const authRequired = !publicRoutes.includes(to.path);
    const requiredRoles = to.meta?.requiredRoles as string[];

    if (authRequired && !currentUser) {
      return next('/login');
    }

    if (to.name === 'login' && currentUser) {
      return next('/');
    }

    if (requiredRoles) {
      if (!currentUser) {
        return next('/login');
      }

      try {
        const hasRole = authStore.hasRequiredRole(requiredRoles);
        if (!hasRole) {
          return next(from);
        }
      } catch (error) {
        console.error('Failed to fetch user teams:', error);
        return next('/error'); // Redirect to an error page or handle it as needed
      }
    }

    next();
  });

  return Router;
});
